from __future__ import division
import es,time,os,glob,sys
import psyco
psyco.full()

addon_module = None
commands = {'g_profile':'gears/profile',
            'g_stop_profile':'gears/stop_profile'}
profile_times = 1
current_addon = None
timer = False
load_time = False
def load():
    a = time.time()
    print '--------------------------------------------'
    print 'Loading GEARS'
    for i in commands:
        es.regclientcmd(i,commands[i])
    for i in commands:
        es.regcmd(i,commands[i])
    print 'Gears loaded in %s seconds'%str(time.time()-a)
    print '--------------------------------------------'

def stop_profile():
    globals()['addon_module'] = None
    if es.getcmduserid():
        es.tell(es.getcmduserid(),"Profiling has been stopped")
    else:
        print "Profiling has been stopped"
    files = glob.glob(es.getAddonPath('gears')+'/'+current_addon+'/*.txt')
    if sys.platform == 'win32': os.system('cls')
    print ' '
    print 'Profiling Results'
    print ' '
    print 'Ran the profiler for %s seconds'%str(time.time()-timer)
    globals()['timer'] = False
    print '-----------------------------------------------------------------'
    print ' '
    print 'Event: Load'
    print 'Number of Iterations   : 1'
    print 'Total time taken       : %s'%load_time
    print 'Average time per call  : %s'%load_time
    print ' '
    for i in files:
        # Run through each file ({EVENT}.txt)
        a = open(i).readlines()
        count_iterations = 0
        count_time = 0
        for line in a:
            line = line.replace('\n','')
            time_taken, num_iterations = line.split(' ')
            count_time+=float(time_taken)
            count_iterations+=int(num_iterations)
        print 'Event: %s'%i.replace('.txt','').replace(es.getAddonPath('gears')+'/'+current_addon,'')
        print 'Number of iterations   : %s'%str(count_iterations)
        print 'Total time taken       : %s'%str(count_time)
        print 'Average time per call  : %s'%str(count_time/count_iterations)
        print ' '
        os.remove(i)
    globals()['current_addon'] = None
            

def profile():
    c = True
    if es.getcmduserid():
        c = False
    if es.getargc() == 1:
        # Command entered with no arguments
        if c:
            print "g_profile [addon_name] [times to profile each function] [optional time]"
        else:
            es.tell(es.getcmduserid(),"g_profile [addon_name] [times to profile each function]")
    else:
        if sys.platform == 'win32': os.system('cls')
        print ' '
        print '---------------Profiler---------------'
        addon = es.getargv(1)
        es.load(addon)
        addon_class = es.import_addon(addon)
        if addon_class:
            globals()['current_addon'] = addon
            globals()['addon_module'] = addon_class
            try:
                globals()['profile_times'] = int(es.getargv(2))
            except:
                globals()['profile_times'] = 1
            es.unload(addon)
            try:
                os.mkdir(es.getAddonPath('gears')+'/'+current_addon)
            except WindowsError,e:
                es.msg('Error in making folder: %s'%e)
            globals()['timer'] = time.time()
            if c:
                print "Addon %s loaded. Profiling has begun"%addon
            else:
                es.tell(es.getcmduserid(),"Addon %s loaded. Profiling has begun"%addon)
            if es.getargv(3):
                es.ServerCommand('es_delayed %s g_stop_profile'%es.getargv(3))
                es.msg('Profiling stopping in %s seconds'%es.getargv(3))
            print '---------------Profiler---------------'
            if 'load' in dir(addon_module):
                t = time.time()
                addon_module.load()
                r = time.time()
                print 'Load took %s seconds'%str(r-t)
                globals()['load_time'] = str(r-t)

def write_to_log(event,line):
    a = open('%s/%s/%s.txt'%(es.getAddonPath('gears'),current_addon,event),'a')
    a.write(line+'\n')
    a.close()

# Lets create the functions, the 1337 way!
print '--------------------------------------------'
print 'Creating functions'
y = time.time()
events = ['bomb_abortdefuse','bomb_abortplant','bomb_beep','bomb_begindefuse','bomb_beinplant',
          'bomb_defused','bomb_dropped','bomb_exploded','bomb_pickup','bomb_planted',
          'break_breakable','break_prop','bullet_impact','door_moving','flashbang_detonate',
          'grenade_bounce','hegrenade_detonate','hostage_call_for_help','hostage_follows',
          'hostage_hurt','hostage_killed','hostage_rescued','hostage_rescued_all',
          'hostage_stops_following','item_pickup','player_activate','player_blind','player_changename',
          'player_chat','player_class','player_connect','player_death','player_disconnect',
          'player_falldamage','player_footstep','player_hurt','player_info','player_jump','player_radio',
          'player_say','player_score','player_shoot','player_spawn','player_team','player_use',
          'round_end','round_start','server_addban','server_cvar','server_removeban','server_shutdown',
          'smokegrenade_detondate','vip_escaped','vip_killed','weapon_fire','weapon_fire_on_empty',
          'weapon_reload','weapon_zoom']

for i in events:
    exec("""def %s(ev):
                if addon_module:
                    if '%s' in dir(addon_module):
                        a = time.time()
                        for i in range(profile_times):
                            addon_module.%s(ev)
                        b = time.time()
                        print '%s took {time} seconds with {times} iterations'.replace('{times}',str(profile_times)).replace('{time}',str(b-a))
                        write_to_log('%s','{TIME} {ITER}'.replace('{TIME}',str(b-a)).replace('{ITER}',str(profile_times)))"""%(i,i,i,i,i))

z = time.time()
print 'Functions created in %s seconds'%str(z-y)
print '--------------------------------------------'
